/* *
 * Copyright (c) 2012, TRIOLOGY GmbH
 *
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 * 3. Neither the name of SCM-Manager; nor the names of its
 *    contributors may be used to endorse or promote products derived from this
 *    software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 * ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * http://bitbucket.org/sdorra/scm-manager
 *
 */

Ext.ns('Triology.bugzilla');

Triology.bugzilla.I18n = {

    titleText : 'Bugzilla Configuration',
    formTitleText : 'Bugzilla',

    bugPrefixText : 'Bug number prefix',
    bugPrefixHelpText : 'A prefix for bug numbers to identify a number as bug number (e.g. \'#\' or\n\'Bug\' will match \'#123\' or \'Bug123\').',
    bugPrefixValidErrorText : 'This charachters are not valid: \n -!$%^&?,.*()_+`´~=:;\"\'<>/\|{}[]',

    bugPrefixCaseSensitiveText : 'Case sensitive',
    bugPrefixCaseSensitiveHelpText : 'The prefix should be matched case sensitive (e.g. \'bug\' will not match \'BUG\').',

    repositoryConfigurationText : 'Do not allow repository configuration',
    repositoryConfigurationHelpText : 'Do not allow repository owners to configure bugzilla instances. \n\
    You have to restart your application server after changing this value.',

    urlText : 'Url',
    urlHelpText : 'Url of Bugzilla installation (with contextpath).',

    autoCloseText : 'Enable Auto-Close',
    autoCloseHelpText : 'Enables the auto close function. SCM-Manager searches for \n\
                      issue keys and auto close words in commit messages. If \n\
                      both found in a message SCM-Manager closes the issue in \n\
                      the bugzilla server.',
    autoCloseDefaultValues : 'fixed, fix, closed, close, resolved, resolve',

    updateIssuesText : 'Update Bugzilla Bugs',
    updateIssuesHelpText : 'Enable the automatic update function. SCM-Manager searches for \n\
                         bug numbers in commit messages. If a bug id is found SCM-Manager\n\
                         updates the bug with a comment.',

    autoCloseWordsText : 'Auto-Close Words',
    autoCloseWordsHelpText : 'Comma separated list of words to enable the auto close function. \n\
                           Each commit message of a changeset is being searched for these words.',

    usernameText : 'Username',
    usernameHelpText : 'Bugzilla login name for connection. Leave this field empty to create the connection\n\
                     with the credentials of the user which is logged in.',

    passwordText : 'Password',
    passwordHelpText : 'Bugzilla password for connection.',
    passwordValidErrorText : 'Password should not be empty.',

    testConfigurationText : 'Test Bugzilla Login',
    testConfigurationHelpText : 'Test login configuration',
    testConfigurationSuccessBoxTitle: 'Success',
    testConfigurationSuccessText: 'Login was successful.',

    // errors
    errorBoxTitle : 'Error',
    errorOnSubmitText : 'Error during config submit.',
    errorValidSubmitText : 'Make sure that your entry is valid.',
    errorOnLoadText : 'Error during config load.',
    errorOnTestText : 'Login failed.',
};


// German translation
if ('zh' == i18n.country) {
    Triology.bugzilla.I18n = {

        titleText : 'Bugzilla 配置',
        formTitleText : 'Bugzilla',

        bugPrefixText : 'Bug 编号前缀',
        bugPrefixHelpText : '用来标记这是个BUG编号的前缀 (如 \'#\' 或\n\'Bug\' 将会匹配 \'#123\' or \'Bug123\').',
        bugPrefixValidErrorText : '这些字符是无效的： \n -!$%^&?,.*()_+`´~=:;\"\'<>/\|{}[]',

        bugPrefixCaseSensitiveText : '区分大小写',
        bugPrefixCaseSensitiveHelpText : '前缀是区分大小写的 (例如 \'bug\' 不会匹配 \'BUG\').',

        repositoryConfigurationText : '禁用仓库配置',
        repositoryConfigurationHelpText : '禁止仓库管理员配置独立的配置，此设置需要重启服务器才可起效',

        urlText : 'URL',
        urlHelpText : 'Bugzilla通知的完整地址',

        autoCloseText : '启用自动关闭',
        autoCloseHelpText : '启用自动关闭功能. SCM-Manager 在提交信息中搜索编号和关键字，如果找到，SCM管理器将会自动关闭服务器中的提交。',
        autoCloseDefaultValues : 'fixed, fix, closed, close, resolved, resolve',

        updateIssuesText : '更新 Bugzilla 问题',
        updateIssuesHelpText : '启用自动更新功能. SCM-Manager在提交中搜索问题编号，如果找到，将会自动更新服务器上的问题。',

        autoCloseWordsText : '自动关闭关键字',
        autoCloseWordsHelpText : '逗号分隔的自动关闭的关键字。每个更改的提交信息都会被用来搜索',

        usernameText : '用户名',
        usernameHelpText : 'Bugzilla登录的用户名。留空则使用当前登录的用户。',

        passwordText : '密码',
        passwordHelpText : '登录的密码',
        passwordValidErrorText : '密码不能为空',

        testConfigurationText : '测试Bugzilla设置',
        testConfigurationHelpText : '测试登录设置',
        testConfigurationSuccessBoxTitle: '成功',
        testConfigurationSuccessText: '登录成功',

        // errors
        errorBoxTitle : '失败',
        errorOnSubmitText : '配置保存失败。',
        errorValidSubmitText : '请确认填写正确。',
        errorOnLoadText : '加载配置失败。',
        errorOnTestText : '登录失败。',
    };
}

if ('de' == i18n.country) {
	Triology.bugzilla.I18n = {

		    titleText : 'Bugzilla Einstellungen',
		    formTitleText : 'Bugzilla',

		    bugPrefixText : 'Bug-Nummer-Prefix',
		    bugPrefixHelpText : 'Ein Prefix, um Nummern als Bug-Nummern identifiziert (z.B. \'#\' oder\n\'Bug\' erkennt \'#123\' oder \'Bug123\').',
		    bugPrefixValidErrorText : 'Folgende Zeichen sind nicht erlaubt: \n -!$%^&?,.*()_+`´~=:;\"\'<>/\|{}[]',

		    bugPrefixCaseSensitiveText : 'Groß-/Kleinschreibung',
		    bugPrefixCaseSensitiveHelpText : 'Der Prefix soll zwischen Groß- und Kleinschreibung unterscheiden (z.B. \'bug\' erkennt nicht \'BUG\').',

		    repositoryConfigurationText : 'Repository-Einstellungen verbieten',
		    repositoryConfigurationHelpText : 'Verhindert, dass Repository-Besitzer eigene Bugzilla-Einstellungen vornehmen können. \n\
		    Der SCM-Manager muss nach einer Änderung neu gestartet werden.',

		    urlText : 'Url',
		    urlHelpText : 'Url der Bugzilla-Installation.',

		    autoCloseText : 'Aktiviere Auto-Close',
		    autoCloseHelpText : 'Aktiviert die Auto-Close-Funktion. Der SCM-Manager sucht nach \n\
		                      Bug-Nummern und Auto-Close-Schlüsselwörtern in Commit-Nachrichten. Wenn \n\
		                      beides gefunden wurde, wird der entsprechende Bug im Bugzilla als in \n\
		                      erledigt markiert.',
		    autoCloseDefaultValues : 'fixed, fix, closed, close, resolved, resolve',

		    updateIssuesText : 'Bugs bearbeiten',
		    updateIssuesHelpText : 'Aktiviert die automatische Bearbeitungsfunktion für Bugzilla-Bugs. Der SCM-Manager\n\
		                         sucht nach Bug-Nummern in Commit-Nachrichten. Wenn dies erfolgreich ist, werden\n\
		                         die entsprechenden Bugs im Bugzilla um Kommentare ergänzt.',

		    autoCloseWordsText : 'Auto-Close-Schlüsselwörter',
		    autoCloseWordsHelpText : 'Komma-getrente Liste an Schlüsselwörtern, die einen Auto-Close aufrufen sollen. \n\
		                           Jede Commit-Nachricht wird nach diesen Wörtern durchsucht.',

		    usernameText : 'Benutzername',
		    usernameHelpText : 'Benutzername des Bugzilla-Benutzers. Wenn dieses Feld leer gelassen wird, wird versucht\n\
		                     sich mit den Benutzerdaten des aktuell angemeldeten Benutzers am Bugzilla anzumelden.',

		    passwordText : 'Passwort',
		    passwordHelpText : 'Passwort des Bugzilla-Benutzers.',
		    passwordValidErrorText : 'Das Passwortfeld darf nicht leer sein!',

		    testConfigurationText : 'Anmeldung am Bugzilla testen',
		    testConfigurationHelpText : 'Anmeldedaten prüfen',
		    testConfigurationSuccessBoxTitle: 'Erfolgreich',
		    testConfigurationSuccessText: 'Der Anmeldeversuch war erfolgreich.',

		    // errors
		    errorBoxTitle : 'Fehler',
		    errorOnSubmitText : 'Ein Fehler ist bei der Übermittlung der Daten aufgetreten.',
		    errorValidSubmitText : 'Bitte Eingaben auf Korrektheit überprüfen.',
		    errorOnLoadText : 'Fehler beim Laden der Konfigurations-Werte.',
		    errorOnTestText : 'Anmeldeversich fehlgeschlagen!',
		};
}

Triology.bugzilla.toggleFields = function(cmps, scope) {
    Ext.each(cmps, function(cmp) {

	var checked = this.getValue();
	// If cmp is a checkbox, use enable/disable.
	if (cmp.getXType() === "checkbox") {
	    if (!checked) {
		cmp.disable();
	    } else {
		cmp.enable();
	    }
	} else {
	    // Add/remove CSS class which indicates disabling.
	    if (!checked) {
		if (!cmp.readOnly) {
		    cmp.addClass('x-item-disabled');
		}
	    } else {
		cmp.removeClass('x-item-disabled');
	    }

	    cmp.setReadOnly(!checked);
	}
    }, scope);
};