Ext.ns("Sonia.activity");
Sonia.activity.ActivityViewerPanel = Ext.extend(Ext.Panel, {
	activityTitle: "活动",
	emptyText: "没有可用的活动记录",
	refreshInterval: 3E5,
	initComponent: function() {
		this.activityStore = new Ext.data.GroupingStore({
			id: "activityStore",
			proxy: new Ext.data.HttpProxy({
				url: restUrl + "activity.json",
				method: "GET"
			}),
			reader: new Ext.data.JsonReader({
				fields: [{
					name: "id",
					mapping: "changeset.id"
				}, {
					name: "date",
					mapping: "changeset.date"
				}, {
					name: "author",
					mapping: "changeset.author"
				}, {
					name: "description",
					mapping: "changeset.description"
				}, {
					name: "modifications",
					mapping: "changeset.modifications"
				}, {
					name: "tags",
					mapping: "changeset.tags"
				}, {
					name: "branches",
					mapping: "changeset.branches"
				}, {
					name: "parents",
					mapping: "changeset.parents"
				}, {
					name: "properties",
					mapping: "changeset.properties"
				}, {
					name: "repository-id"
				}, {
					name: "repository-name"
				}, {
					name: "repository-type"
				}],
				root: "activities"
			}),
			remoteSort: true,
			remoteGroup: true,
			groupOnSort: false,
			groupField: "repository-id",
			groupDir: "AES",
			autoLoad: false,
			autoDestroy: true
		});
		var config = {
			title: this.activityTitle,
			items: [{
				id: "activityGrid",
				xtype: "activityGrid",
				store: this.activityStore,
				view: new Ext.grid.GroupingView({
					emptyText: this.emptyText,
					forceFit: false,
					groupTextTpl: '{group} / ({[values.rs.length]} {[values.rs.length \x3e 1 ? "变更" : "变更"]})'
				})
			}]
		};
		Ext.TaskMgr.start({
			run: this.refreshStore,
			interval: this.refreshInterval,
			scope: this
		});
		Ext.apply(this, Ext.apply(this.initialConfig, config));
		Sonia.activity.ActivityViewerPanel.superclass.initComponent.apply(this, arguments)
	},
	refreshStore: function() {
		this.activityStore.reload()
	}
});
Ext.reg("activityViewerPanel", Sonia.activity.ActivityViewerPanel);