﻿Ext.chart.Chart.CHART_URL = "resources/extjs/resources/charts.swf";
Ext.ns("Sonia.statistic");
Sonia.statistic.LinkPanel = Ext.extend(Ext.Panel, {initComponent: function () {
	var links = [
		{xtype: "link", style: "font-weight: bold", text: "按作者提交统计", handler: this.openCommitsPerAuthor, scope: this},
		{xtype: "link", style: "font-weight: bold", text: "按月提交统计", handler: this.openCommitsPerMonth, scope: this},
		{xtype: "link", style: "font-weight: bold", text: "按周提交统计", handler: this.openCommitsPerWeekday, scope: this},
		{xtype: "link", style: "font-weight: bold", text: "按小时提交统计", handler: this.openCommitsPerHour,
			scope: this},
		{xtype: "link", style: "font-weight: bold", text: "最常修改文件", handler: this.openTopModifiedFiles, scope: this},
		{xtype: "link", style: "font-weight: bold", text: "最常用单词", handler: this.openTopWords, scope: this},
		{xtype: "link", style: "font-weight: bold", text: "文件修改数", handler: this.openFileModificationCount, scope: this}
	];
	if (admin)links.push({xtype: "link", style: "font-weight: bold", text: "重建统计数据", handler: this.rebuildStatistic, scope: this});
	var config = {title: "统计",
		padding: 5, bodyCssClass: "x-panel-mc", layout: "table", defaults: {bodyStyle: "padding: 5px"}, autoScroll: true, layoutConfig: {columns: 1}, items: links};
	Ext.apply(this, Ext.apply(this.initialConfig, config));
	Sonia.statistic.LinkPanel.superclass.initComponent.apply(this, arguments)
}, rebuildStatistic: function () {
	Ext.MessageBox.show({title: "重建统计数据", msg: "重建库 " + this.item.name + " 的统计数据?", buttons: Ext.MessageBox.OKCANCEL, icon: Ext.MessageBox.QUESTION, fn: function (result) {
		if (result === "ok") {
			if (debug)console.debug("重建统计数据 for " +
				this.item.name);
			var el = this.el;
			var tid = setTimeout(function () {
				el.mask("加载中 ...")
			}, 100);
			Ext.Ajax.request({url: restUrl + "plugins/statistic/" + this.item.id + "/rebuild.json", method: "POST", scope: this, success: function () {
				clearTimeout(tid);
				el.unmask()
			}, failure: function (result) {
				clearTimeout(tid);
				el.unmask();
				main.handleFailure(result.status, "重建失败", "无法重建统计数据")
			}})
		}
	}, scope: this})
}, openCommitsPerMonth: function () {
	main.addTab({id: "commitsPerMonth;" + this.item.id, xtype: "statisticCommitsPerMonthPanel",
		repository: this.item, closable: true})
}, openCommitsPerWeekday: function () {
	main.addTab({id: "commitsPerWeekday;" + this.item.id, xtype: "statisticCommitsPerWeekdayPanel", repository: this.item, closable: true})
}, openCommitsPerAuthor: function () {
	main.addTab({id: "commitsPerAuthor;" + this.item.id, xtype: "statisticCommitsPerAuthorPanel", repository: this.item, closable: true})
}, openCommitsPerHour: function () {
	main.addTab({id: "commitsPerHour;" + this.item.id, xtype: "statisticCommitsPerHourPanel", repository: this.item, closable: true})
},
	openTopModifiedFiles: function () {
		main.addTab({id: "topModifiedFiles;" + this.item.id, xtype: "statisticTopModifiedFilesPanel", repository: this.item, closable: true})
	}, openFileModificationCount: function () {
		main.addTab({id: "fileModificationCount;" + this.item.id, xtype: "statisticFileModificationCount", repository: this.item, closable: true})
	}, openTopWords: function () {
		main.addTab({id: "topWords;" + this.item.id, xtype: "statisticTopWordsPanel", repository: this.item, closable: true})
	}});
Ext.reg("statisticLinkPanel", Sonia.statistic.LinkPanel);
Sonia.repository.openListeners.push(function (repository, panels) {
	panels.push({xtype: "statisticLinkPanel", item: repository})
});