Ext.ns("Sonia.webhook");
Sonia.webhook.I18n = {
	formTitleText: "WEB钩子",
	colUrlText: "URL路径规则",
	colEveryCommitText: "每次提交都执行",
	colSendCommitData: "发送提交数据",
	colHttpMethod: "HTTP方法",
	addText: "添加",
	removeText: "移除",
	webhookGridHelpText: '添加或移除仓库的WEB钩子. \n    "URL路径规则" 栏确定了远程地址. \n    地址中可以使用 ${repository.name} 作为占位符.\n    如果启用"每次提交都执行"，那么对于一次推送中的每次提交将都会触发请求. \n    如果没有启用那么将会每次推送都只发送一个请求. \n    如果选中了"发送提交数据"，插件 \n    将会把提交数据作为JSON内容在请求中发送. \n    如果HTTP方法选择为 AUTO , 插件将会在默认情况下使用GET，而在有数据发送时使用POST.',
	addIcon: "resources/images/add.gif",
	removeIcon: "resources/images/delete.gif",
	helpIcon: "resources/images/help.gif"
};
Sonia.webhook.createColModel = function() {
	return new Ext.grid.ColumnModel({
		defaults: {
			sortable: false,
			editable: true
		},
		columns: [{
			id: "urlPattern",
			dataIndex: "urlPattern",
			header: Sonia.webhook.I18n.colUrlText,
			editor: Ext.form.TextField
		}, {
			id: "executeOnEveryCommit",
			xtype: "checkcolumn",
			dataIndex: "executeOnEveryCommit",
			header: Sonia.webhook.I18n.colEveryCommitText
		}, {
			id: "sendCommitData",
			xtype: "checkcolumn",
			dataIndex: "sendCommitData",
			header: Sonia.webhook.I18n.colSendCommitData
		}, {
			id: "method",
			dataIndex: "method",
			header: Sonia.webhook.I18n.colHttpMethod,
			editor: new Ext.form.ComboBox({
				valueField: "method",
				displayField: "method",
				typeAhead: false,
				editable: false,
				triggerAction: "all",
				mode: "local",
				store: new Ext.data.SimpleStore({
					fields: ["method"],
					data: [
						["AUTO"],
						["GET"],
						["POST"],
						["PUT"]
					]
				})
			})
		}]
	})
};
Sonia.webhook.createRowSelectionModel = function() {
	return new Ext.grid.RowSelectionModel({
		singleSelect: true
	})
};
Sonia.repository.openListeners.push(function(repository, panels) {
	if (Sonia.repository.isOwner(repository)) panels.push({
		xtype: "webhookRepositoryPanel",
		item: repository
	})
});
registerGeneralConfigPanel({
	id: "webhookGlobalPanel",
	xtype: "webhookGlobalPanel"
});